#include "context_menu.h"

unsigned contextmenu_item_simple_bpm::get_num_items()
{
	// Change to 2 once the manual tapping function is complete
	return 2;
}

void contextmenu_item_simple_bpm::get_item_name(unsigned p_index, pfc::string_base & p_out)
{
	switch (p_index)
	{
	    case mnuAutoAnalysis:
		    p_out = "Automatically analyse BPMs...";
			break; 
		case mnuManualAnalysis:
			p_out = "Manually tap BPM for current track...";
			break;
		default:
			break;
	}
}

void contextmenu_item_simple_bpm::get_item_default_path(unsigned p_index, pfc::string_base & p_out)
{
	p_out = "BPM Analysis";
}

void contextmenu_item_simple_bpm::context_command(unsigned p_index, metadb_handle_list_cref p_data, const GUID& p_caller)
{
	bpm_manual_dialog* m_bpm_manual_dialog;
	service_ptr_t<bpm_auto_analysis_thread> thread = new service_impl_t<bpm_auto_analysis_thread>(p_data);

	switch (p_index)
	{
	    case mnuAutoAnalysis:
			thread->start();
			break;
		case mnuManualAnalysis:
			m_bpm_manual_dialog = new bpm_manual_dialog();
			m_bpm_manual_dialog->Create(core_api::get_main_window(), NULL);
			m_bpm_manual_dialog->ShowWindow(SW_SHOWNORMAL);
			break;
		default:
			break;
	}
}

GUID contextmenu_item_simple_bpm::get_item_guid(unsigned p_index)
{
	switch (p_index)
	{
	    case mnuAutoAnalysis:
			return guid_auto_bpm;
			break;
		case mnuManualAnalysis:
			return guid_manual_bpm;
			break;
		default:
			break;
	}

	return pfc::guid_null;
}

bool contextmenu_item_simple_bpm::get_item_description(unsigned p_index, pfc::string_base & p_out)
{
	switch (p_index)
	{
	    case mnuAutoAnalysis:
	        p_out = "Perform an automatic BPM analysis of the selected tracks.";
			break;
		case mnuManualAnalysis:
			p_out = "Manually tap the BPM of the selected track.";
			break;
		default:
			return false;
			break;
	}

	return true;
}

static contextmenu_item_factory_t<contextmenu_item_simple_bpm> contextmenu_factory;